# FIXME:  get libswt-gtk-print.so out of jar and symlink

Epoch:        1

%define fedora		0
%define redhat		1
%if %{fedora}
%define gcj_support 	1
%else
%define gcj_support 	0
%endif
%define pkg_summary             Visual Editor plugin for Eclipse
%define eclipse_name            eclipse
%define major                   1
%define minor                   2
%define majmin                  %{major}.%{minor}
%define micro                   0
%define eclipse_base            %{_datadir}/%{eclipse_name}
%define eclipse_lib_base        %{_libdir}/%{eclipse_name}

# All arches line up except i386 -> x86
%ifarch %{ix86}
%define eclipse_arch    x86
%else
%define eclipse_arch   %{_arch}
%endif

Summary:       %{pkg_summary}
Name:          %{eclipse_name}-ve
Version:       %{majmin}.%{micro}
Release:       1jpp_2rh
License:       Eclipse Public License - v 1.0 (EPL) <http://www.eclipse.org/legal/epl-v10.html>
Group:         Text Editors/Integrated Development Environments (IDE)
URL:           http://www.eclipse.org/vep/

# Here's how to generate the source drop for VE 1.2:
#
# mkdir -p temp/home && cd temp
# touch home/.cvspass
# cvs -d :pserver:anonymous@dev.eclipse.org:/home/tools \
#   co -r R_1_2 org.eclipse.ve.releng.builder
# pushd org.eclipse.ve.releng.builder
# 
# # This patch does the following:
# #   1. add a fetch target to grab the source
# #   2. don't grab EMF and GEF during build
#
# patch -p0 << _EOF_
# 
# Index: build.xml
# ===================================================================
# RCS file: /home/tools/org.eclipse.ve.releng.builder/build.xml,v
# retrieving revision 1.4
# diff -u -p -r1.4 build.xml
# --- build.xml	5 Nov 2004 20:28:18 -0000	1.4
# +++ build.xml	25 Jul 2006 16:09:48 -0000
# @@ -26,5 +26,16 @@
#  			<property name="builder" value="${basedir}/${component}" />
#  		</ant>
#  	</target>
# +
# +       <target name="fetch" depends="init">
# +               <ant antfile="build.xml" dir="\${pde.build.scripts}"
# +                               target="preBuild">
# +                       <property name="builder" value="\${basedir}/\${component}" />
# +               </ant>
# +               <ant antfile="build.xml" dir="\${pde.build.scripts}"
# +                               target="fetch">
# +                       <property name="builder" value="\${basedir}/\${component}" />
# +               </ant>
# +       </target>
#  	
# -</project>
# \ No newline at end of file
# +</project>
# Index: sdk/customTargets.xml
# ===================================================================
# RCS file: /home/tools/org.eclipse.ve.releng.builder/sdk/customTargets.xml,v
# retrieving revision 1.10
# diff -u -p -r1.10 customTargets.xml
# --- sdk/customTargets.xml	4 Jun 2005 17:10:42 -0000	1.10
# +++ sdk/customTargets.xml	25 Jul 2006 16:09:48 -0000
# @@ -67,12 +67,12 @@
#  <!-- Steps to do after setup but before starting the build proper -->
#  <!-- ===================================================================== -->
#  <target name="postSetup">
# -	<available file="${buildDirectory}/plugins/org.eclipse.platform/plugin.xml" property="baseExists" />
# -	<antcall target="getBaseEclipse" />
# -	<available file="${buildDirectory}/plugins/org.eclipse.emf/plugin.xml" property="emfExists" />
# -	<antcall target="getEMF" />
# -	<available file="${buildDirectory}/plugins/org.eclipse.gef/plugin.xml" property="gefExists" />
# -	<antcall target="getGEF" />	
# +<!--        <available file="${buildDirectory}/plugins/org.eclipse.platform/plugin.xml" property="baseExists" />-->
# +<!--        <antcall target="getBaseEclipse" />-->
# +<!--        <available file="${buildDirectory}/plugins/org.eclipse.emf/plugin.xml" property="emfExists" />-->
# +<!--        <antcall target="getEMF" />-->
# +<!--        <available file="${buildDirectory}/plugins/org.eclipse.gef/plugin.xml" property="gefExists" />-->
# +<!--        <antcall target="getGEF" />	-->
#  </target>
#  
#  <!-- ===================================================================== -->
# @@ -188,4 +188,4 @@
#  	<echo message="You must specify a target when invoking this file" />
#  </target>
#  
# -</project>
# \ No newline at end of file
# +</project>
# 
# _EOF_
# 
# # Fetch the actual source
# 
# java -cp /usr/share/eclipse/startup.jar \
#   -Duser.home=../home org.eclipse.core.launcher.Main \
#   -application org.eclipse.ant.core.antRunner \
#   -buildfile build.xml \
#   -DbaseLocation=/usr/share/eclipse \
#   -Dpde.build.scripts=/usr/share/eclipse/plugins/org.eclipse.pde.build/scripts \
#   -Dcomponent=sdk \
#   -DbaseExists=true \
#   -DmapCvsRoot=":pserver:anonymous@dev.eclipse.org:/home/tools" \
#   -DmapVersionTag=R_1_2 \
#   fetch
#   
# popd
# 
# # Make the source tarball
# tar jcf eclipse-ve-fetched-src-1.2.tar.bz2 org.eclipse.ve.releng.builder

Source0:	%{name}-fetched-src-%{version}.tar.bz2
# http://dev.eclipse.org/viewcvs/indextools.cgi/org.eclipse.ve.swt/native-src/swt-gtk-print-src.zip
Source1:        swt-gtk-print-src.zip

# Include the perfmsr.jar stub in the build classpath
Patch0:         %{name}-jem.util.patch
# This lets us use the IBM JVM for building
Patch1:         %{name}-dontsetbootclasspath.patch

BuildRequires:       eclipse-pde >= 1:3.2.0
BuildRequires:       eclipse-pde < 1:3.2.1
BuildRequires:       eclipse-gef
BuildRequires:       eclipse-emf-sdo
# For the JNI bits (libswt-gtk-print)
BuildRequires:       gcc
BuildRequires:       gtk2-devel
BuildRequires:       glib2-devel
BuildRequires:       xorg-x11-devel
%if %{gcj_support}
BuildRequires:    gcc-java >= 4.0.2
BuildRequires:    java-gcj-compat-devel >= 1.0.33
Requires(post):   java-gcj-compat >= 1.0.33
Requires(postun): java-gcj-compat >= 1.0.33
%else
BuildRequires:    java-devel >= 1.4.2
%endif

ExclusiveArch:    %{ix86} x86_64 ppc ia64

Requires:      eclipse-gef
Requires:      eclipse-emf-sdo
Requires:      eclipse-jdt >= 1:3.2.0
Requires:      eclipse-jdt < 1:3.2.1
Requires:      %{name}-jem = %{epoch}:%{version}-%{release}

BuildRoot: %{_tmppath}/%{name}-buildroot

%package       jem
Summary:       Eclipse Visual Editor Java EMF Model
Group:         Text Editors/Integrated Development Environments (IDE)
Requires:      eclipse-jdt >= 1:3.2.0
Requires:      eclipse-jdt < 1:3.2.1

%package       jem-sdk
Summary:       Eclipse Visual Editor Java EMF Model Source (SDK)
Group:         Text Editors/Integrated Development Environments (IDE)
Requires:      %{name}-jem = %{epoch}:%{version}-%{release}

%package       sdk
Summary:       Eclipse Visual Editor Source (SDK)
Group:         Text Editors/Integrated Development Environments (IDE)
Requires:      %{name} = %{epoch}:%{version}-%{release}
Requires:      %{name}-jem-sdk = %{epoch}:%{version}-%{release}

%description
The eclipse-ve package contains the Eclipse Visual Editor.

%description jem
Eclipse Visual Editor Java EMF Model.

%description jem-sdk
Source for Eclipse Visual Editor Java EMF Model for use within Eclipse.

%description sdk
Source for Eclipse Visual Editor for use within Eclipse (equivalent to upstream
SDK release).

%prep
%setup -q -c 
pushd org.eclipse.ve.releng.builder/
unzip -qq %{SOURCE1}
%patch0 -p0
%patch1 -p1

# Remove the win32 stuff since we don't ship it or have it to build against
rm -rf src/eclipse/plugins/org.eclipse.ve.swt/vm_swt/org/eclipse/ve/internal/swt/targetvm/win32

# Remove the pre-build shared libraries
rm -f src/eclipse/plugins/org.eclipse.ve.swt/os/linux/ia64/libswt-gtk-print.so
rm -f src/eclipse/plugins/org.eclipse.ve.swt/os/linux/x86_64/libswt-gtk-print.so
rm -f src/eclipse/plugins/org.eclipse.ve.swt/os/linux/x86/libswt-gtk-print.so
popd

%build
export JAVA_HOME=%{java_home}

# See comments in the script to understand this.
/bin/sh -x %{eclipse_base}/buildscripts/copy-platform SDK %{eclipse_base} \
  draw2d emf gef

SDK=$(cd SDK && pwd)

mkdir home
homedir=$(cd home > /dev/null && pwd)

cd org.eclipse.ve.releng.builder/

pushd swt-gtk-print
%ifarch x86_64 ppc64
sed --in-place "s:/usr/X11R6/lib:/usr/X11R6/lib64:g" makefile
%endif
make -f makefile
%ifarch x86_64 ia64 ppc64 s390x
cp bits64/libswt-gtk-print.so \
  ../src/eclipse/plugins/org.eclipse.ve.swt/os/linux/%{eclipse_arch}
%else
cp libswt-gtk-print.so \
  ../src/eclipse/plugins/org.eclipse.ve.swt/os/linux/%{eclipse_arch}
%endif
popd

%ifarch x86_64 ia64 ppc64 s390x
mv src/eclipse/plugins/org.eclipse.ve.swt/vm_swt/org/eclipse/ve/internal/swt/targetvm/unix/{bits64/,}ImageCapture.java
rmdir src/eclipse/plugins/org.eclipse.ve.swt/vm_swt/org/eclipse/ve/internal/swt/targetvm/unix/bits64
rm -rf src/eclipse/plugins/org.eclipse.ve.swt/vm_swt/org/eclipse/ve/internal/swt/targetvm/macosx
%endif

java -cp $SDK/startup.jar \
    -Duser.home=$homedir \
     org.eclipse.core.launcher.Main \
    -application org.eclipse.ant.core.antRunner \
    -Dcomponent=sdk \
    -DjavacFailOnError=true \
    -DdontUnzip=true \
    -DbaseLocation=$SDK \
    -Dbaseos=linux \
    -Dbasews=gtk \
    -Dbasearch=%{eclipse_arch} \
    -Dpde.build.scripts=$SDK/plugins/org.eclipse.pde.build/scripts

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/%{eclipse_base}
mkdir -p ${RPM_BUILD_ROOT}/%{eclipse_lib_base}
mkdir -p ${RPM_BUILD_ROOT}/%{_libdir}

for file in $(pwd)/org.eclipse.ve.releng.builder/src/eclipse/I.*/*.zip; do
  case $file in
    *eclipse*)
      # The ".." is needed since the zip files contain "eclipse/foo".
      (cd $RPM_BUILD_ROOT/%{eclipse_base}/.. && unzip -qq -o $file)
      ;;
  esac
done

# FIXME:
# JNI bits - we should really have libswt-gtk-print.so in /usr/lib/eclipse
#pushd $RPM_BUILD_ROOT/%{eclipse_base}/plugins/org.eclipse.ve.swt_%{version}/os/linux/%{eclipse_arch}
#  mv libswt-gtk-print.so $RPM_BUILD_ROOT/%{eclipse_lib_base}
#  ln -s %{eclipse_lib_base}/libswt-gtk-print.so .
#popd
#
#pushd $RPM_BUILD_ROOT/%{_libdir}
#  ln -s %{eclipse_lib_base}/libswt-gtk-print.so .
#popd

# These are already included in the Eclipse SDK
rm $RPM_BUILD_ROOT/%{eclipse_base}/epl-v10.html
rm $RPM_BUILD_ROOT/%{eclipse_base}/notice.html

%if %{gcj_support}
  aot-compile-rpm
%endif

%clean 
rm -rf ${RPM_BUILD_ROOT}

%if %{gcj_support}
%post
%{_bindir}/rebuild-gcj-db
%postun jem
%{_bindir}/rebuild-gcj-db
%endif

%files
%defattr(-,root,root)
#%dir %{_libdir}
#%dir %{eclipse_lib_base}
%{eclipse_base}/features/org.eclipse.ve_*
%{eclipse_base}/plugins/org.eclipse.ve.cde_*
%{eclipse_base}/plugins/org.eclipse.ve.doc_*
%{eclipse_base}/plugins/org.eclipse.ve.java.core_*
%{eclipse_base}/plugins/org.eclipse.ve.jfc_*
%{eclipse_base}/plugins/org.eclipse.ve.propertysheet_*
%{eclipse_base}/plugins/org.eclipse.ve.swt_*
%{eclipse_base}/plugins/org.eclipse.ve_*
#%{eclipse_lib_base}/libswt-gtk-print.so
#%{_libdir}/libswt-gtk-print.so
%if %{gcj_support}
%{_libdir}/gcj/%{name}/calendar.jar*
%{_libdir}/gcj/%{name}/cde.jar*
%{_libdir}/gcj/%{name}/cdm.jar*
%{_libdir}/gcj/%{name}/codegen.jar*
%{_libdir}/gcj/%{name}/common.jar*
%{_libdir}/gcj/%{name}/core.jar*
%{_libdir}/gcj/%{name}/formsbeaninfo.jar*
%{_libdir}/gcj/%{name}/iclock.jar*
%{_libdir}/gcj/%{name}/javaremotevm.jar*
%{_libdir}/gcj/%{name}/jbcfswtvm.jar*
%{_libdir}/gcj/%{name}/jfc.jar*
%{_libdir}/gcj/%{name}/jfcbeaninfo.jar*
%{_libdir}/gcj/%{name}/jfccodegen.jar*
%{_libdir}/gcj/%{name}/jfccommon.jar*
%{_libdir}/gcj/%{name}/jfcvm.jar*
%{_libdir}/gcj/%{name}/propertysheet.jar*
%{_libdir}/gcj/%{name}/swtCommon.jar*
%{_libdir}/gcj/%{name}/swtbeaninfo.jar*
%{_libdir}/gcj/%{name}/swtcodegen.jar*
%{_libdir}/gcj/%{name}/vcelauncher.jar*
%{_libdir}/gcj/%{name}/ve_swt.jar*
%endif

%files jem
%defattr(-,root,root)
%{eclipse_base}/features/org.eclipse.jem_*
%{eclipse_base}/plugins/com.ibm.etools.emf.event_*
%{eclipse_base}/plugins/org.eclipse.jem.beaninfo_*
%{eclipse_base}/plugins/org.eclipse.jem.proxy_*
%{eclipse_base}/plugins/org.eclipse.jem.sdk_*
%{eclipse_base}/plugins/org.eclipse.jem.ui_*
%{eclipse_base}/plugins/org.eclipse.jem.util_*
%{eclipse_base}/plugins/org.eclipse.jem.workbench_*
%{eclipse_base}/plugins/org.eclipse.jem_*
%if %{gcj_support}
%{_libdir}/gcj/%{name}/beaninfo.jar*
%{_libdir}/gcj/%{name}/beaninfocommon.jar*
%{_libdir}/gcj/%{name}/beaninfovm.jar*
%{_libdir}/gcj/%{name}/event.jar*
%{_libdir}/gcj/%{name}/initparser.jar*
%{_libdir}/gcj/%{name}/javainst.jar*
%{_libdir}/gcj/%{name}/mofjava.jar*
%{_libdir}/gcj/%{name}/proxy.jar*
%{_libdir}/gcj/%{name}/proxycommon.jar*
%{_libdir}/gcj/%{name}/proxyide.jar*
%{_libdir}/gcj/%{name}/proxyremote.jar*
%{_libdir}/gcj/%{name}/remotecommon.jar*
%{_libdir}/gcj/%{name}/remotevm.jar*
%{_libdir}/gcj/%{name}/ui.jar*
%{_libdir}/gcj/%{name}/util.jar*
%{_libdir}/gcj/%{name}/workbench.jar*
%endif

%files jem-sdk
%defattr(-,root,root)
%{eclipse_base}/features/org.eclipse.jem.sdk_*
%{eclipse_base}/features/org.eclipse.jem.source_*
%{eclipse_base}/plugins/org.eclipse.jem.source_*

%files sdk
%defattr(-,root,root)
%{eclipse_base}/features/org.eclipse.ve.sdk_*
%{eclipse_base}/features/org.eclipse.ve.source_*
%{eclipse_base}/plugins/org.eclipse.ve.sdk_*
%{eclipse_base}/plugins/org.eclipse.ve.source_*

%changelog
* Tue Aug 22 2006 Andrew Overholt <overholt@redhat.com> 1.2.0-1jpp_2rh
- -devel -> -sdk to match upstream.

* Tue Aug 01 2006 Andrew Overholt <overholt@redhat.com> 1.2.0-1jpp_1rh
- 1.2.0.
- Don't build the 32-bit stuff on 64-bit platforms.

* Mon Apr 10 2006 Andrew Overholt <overholt@redhat.com> 1:1.1.0.1-1jpp_1rh
- 1.1.0.1 (not sure why earlier versions were 3.0.1).
- General specfile cleanups.
- Add gcj bits.
- Patches so that we can build with IBM JVM.
- Build _all_ of the jars and .sos.
- Add patch for 64-bit issues (e.o#112577).

* Mon Jun 27 2005 Aaron Luchko <aluchko@redhat.com> 3.0.1-5
- Added x86_64

* Mon May 2 2005 Ben Konrath <bkonrath@redhat.com> 3.0.1-4
- Build against Eclipse 3.0.2

* Thu Mar 30 2005 Phil Muldoon <pmuldoon@redhat.com> 3.0.1-3
- Import sources from devel into RHEL-4
- Changed pde.build.scripts to point to 3.0.1

* Thu Dec 09 2004 Phil Muldoon <pmuldoon@redhat.com> 3.0.1-1
- Initial Build
